BASE_MAP = {
    ('a',):       {'html': 'a', 'latex': 'a'},
    ('A',):       {'html': '&#x0251;', 'latex': 'A'},
    ('b',):       {'html': 'b', 'latex': 'b'},
    ('b', '<'):   {'html': '&#x0253;', 'latex': '\\!b'},
    ('B',):       {'html': '&#x03B2;', 'latex': 'B'},
    ('B\\',):     {'html': '&#x0299;', 'latex': '\\;B'},
    ('c',):       {'html': 'c', 'latex': 'c'},
    ('C',):       {'html': '&#x00E7;', 'latex': '\\c{c}'},
    ('d',):       {'html': 'd', 'latex': 'd'},
    ('d', '`'):   {'html': '&#x0256;', 'latex': '\\:d'},
    ('d', '<'):   {'html': '&#x0257;', 'latex': '\\!d'},
    ('D',):       {'html': '&#x00F0;', 'latex': 'D'},
    ('e',):       {'html': 'e', 'latex': 'e'},
    ('E',):       {'html': '&#x025B;', 'latex': 'E'},
    ('f',):       {'html': 'f', 'latex': 'f'},
    ('F',):       {'html': '&#x0271;', 'latex': 'M'},
    ('g',):       {'html': 'g', 'latex': 'g'},
    ('g', '<'):   {'html': '&#x0260;', 'latex': '\\!g'},
    ('G',):       {'html': '&#x0263;', 'latex': 'G'},
    ('G\\',):     {'html': '&#x0262;', 'latex': '\\;G'},
    ('G\\', '<'): {'html': '&#x029B;', 'latex': '\\!G'},
    ('h',):       {'html': 'h', 'latex': 'h'},
    ('h\\',):     {'html': '&#x0266;', 'latex': 'H'},
    ('H',):       {'html': '&#x0265;', 'latex': '4'},
    ('H\\',):     {'html': '&#x029C;', 'latex': '\\;H'},
    ('i',):       {'html': 'i', 'latex': 'i'},
    ('I',):       {'html': '&#x026A;', 'latex': 'I'},
    ('I\\',):     {'html': '&#x026A;&#x0308;', 'latex': '\\"I'},
    ('j',):       {'html': 'j', 'latex': 'j'},
    ('j\\',):     {'html': '&#x029D;', 'latex': 'J'},
    ('J',):       {'html': '&#x0272;', 'latex': '{\\textltailn}'},
    ('J\\',):     {'html': '&#x025F;', 'latex': '{\\textbardotlessj}'},
    ('J\\', '<'): {'html': '&#x0284;', 'latex': '\\!j'},
    ('k',):       {'html': 'k', 'latex': 'k'},
    ('K',):       {'html': '&#x026C;', 'latex': '{\\textbeltl}'},
    ('K\\',):     {'html': '&#x026E;', 'latex': '{\\textlyoghlig}'},
    ('l',):       {'html': 'l', 'latex': 'l'},
    ('l', '`'):   {'html': '&#x026D;', 'latex': '\\:l'},
    ('l\\',):     {'html': '&#x027A;', 'latex': '{\\textturnlonglegr}'},
    ('L',):       {'html': '&#x028E;', 'latex': 'L'},
    ('L\\',):     {'html': '&#x029F;', 'latex': '\\;L'},
    ('m',):       {'html': 'm', 'latex': 'm'},
    ('M',):       {'html': '&#x026F;', 'latex': 'W'},
    ('M\\',):     {'html': '&#x0270;', 'latex': '{\\textturnmrleg}'},
    ('n',):       {'html': 'n', 'latex': 'n'},
    ('n', '`'):   {'html': '&#x0273;', 'latex': '\\:n'},
    ('N',):       {'html': '&#x014B;', 'latex': 'N'},
    ('N\\',):     {'html': '&#x0274;', 'latex': '\\;N'},
    ('o',):       {'html': 'o', 'latex': 'o'},
    ('O',):       {'html': '&#x0254;', 'latex': 'O'},
    ('O\\',):     {'html': '&#x0298;', 'latex': '\\!o'},
    ('p',):       {'html': 'p', 'latex': 'p'},
    ('p\\',):     {'html': '&#x0278;', 'latex': 'F'},
    ('q',):       {'html': 'p', 'latex': 'p'},
    ('Q',):       {'html': '&#x0252;', 'latex': '6'},
    ('r',):       {'html': 'r', 'latex': 'r'},
    ('r', '`'):   {'html': '&#x027D;', 'latex': '\\:r'},
    ('r\\',):     {'html': '&#x0279;', 'latex': '\\*r'},
    ('r\\', '`'): {'html': '&#x027B;', 'latex': '\\:R'},
    ('R',):       {'html': '&#x0281;', 'latex': 'K'},
    ('R\\',):     {'html': '&#x0280;', 'latex': '\\;R'},
    ('s',):       {'html': 's', 'latex': 's'},
    ('s', '`'):   {'html': '&#x0282;', 'latex': '\\:s'},
    ('s\\',):     {'html': '&#x0255;', 'latex': 'C'},
    ('S',):       {'html': '&#x0283;', 'latex': 'S'},
    ('t',):       {'html': 't', 'latex': 't'},
    ('t', '`'):   {'html': '&#x0288;', 'latex': '\\:t'},
    ('T',):       {'html': '&#x03B8;', 'latex': 'T'},
    ('u',):       {'html': 'u', 'latex': 'u'},
    ('U',):       {'html': '&#x028A;', 'latex': 'U'},
    ('U\\',):     {'html': '&#x028A;&#x0308;', 'latex': '\\"U'},
    ('v',):       {'html': 'v', 'latex': 'v'},
    ('v\\',):     {'html': '&#x028B;', 'latex': 'V'},
    ('V',):       {'html': '&#x028C;', 'latex': '2'},
    ('w',):       {'html': 'w', 'latex': 'w'},
    ('W',):       {'html': '&#x028D;', 'latex': '\\*w'},
    ('x',):       {'html': 'x', 'latex': 'x'},
    ('x\\',):     {'html': '&#x0267;', 'latex': '{\\texththeng}'},
    ('X',):       {'html': '&#x03C7;', 'latex': 'X'},
    ('X\\',):     {'html': '&#x0127;', 'latex': '{\\textcrh}'},
    ('y',):       {'html': 'y', 'latex': 'y'},
    ('Y',):       {'html': '&#x028F;', 'latex': 'Y'},
    ('z',):       {'html': 'z', 'latex': 'z'},
    ('z', '`'):   {'html': '&#x0290;', 'latex': '\\:z'},
    ('z\\',):     {'html': '&#x0291;', 'latex': '{\\textctz}'},
    ('Z',):       {'html': '&#x0292;', 'latex': 'Z'},
    ('.',):       {'html': '.', 'latex': '.'},
    ('"',):       {'html': '&#x02C8;', 'latex': '"'},
    ('%',):       {'html': '&#x02CC;', 'latex': '""'},
    (':',):       {'html': '&#x02D0;', 'latex': ':'},
    (':\\',):     {'html': '&#x02D1;', 'latex': ';'},
    ('@',):       {'html': '&#x0259;', 'latex': '@'},
    ('@\\',):     {'html': '&#x0258;', 'latex': '9'},
    ('{',):       {'html': '&#x00E6;', 'latex': '{\\ae}'},
    ('}',):       {'html': '&#x0289;', 'latex': '0'},
    ('1',):       {'html': '&#x0268;', 'latex': '1'},
    ('2',):       {'html': '&#x00F8;', 'latex': '{\\o}'},
    ('3',):       {'html': '&#x025C;', 'latex': '3'},
    ('3\\',):     {'html': '&#x025E;', 'latex': '{\\textcloserevepsilon}'},
    ('4',):       {'html': '&#x027E;', 'latex': 'R'},
    ('5',):       {'html': '&#x026B;', 'latex': '{\\textltilde}'},
    ('6',):       {'html': '&#x0250;', 'latex': '5'},
    ('7',):       {'html': '&#x0264;', 'latex': '7'},
    ('8',):       {'html': '&#x0275;', 'latex': '8'},
    ('9',):       {'html': '&#x0153;', 'latex': '{\\oe}'},
    ('&',):       {'html': '&#x0276;', 'latex': '{\\OE}'},
    ('?',):       {'html': '&#x0294;', 'latex': 'P'},
    ('?\\',):     {'html': '&#x0295;', 'latex': 'Q'},
    ('<\\',):     {'html': '&#x02A2;', 'latex': '{\\textbarrevglotstop}'},
    ('^',):       {'html': '&#xA71B;', 'latex': '{\\textupstep}'},
    ('!',):       {'html': '&#xA71C;', 'latex': '{\\textdownstep}'},
    ('!\\',):     {'html': '&#x01C3;', 'latex': '!'},
    ('|',):       {'html': '&#x007C;', 'latex': '{\\textvertline}'},
    ('|\\',):     {'html': '&#x01C0;', 'latex': '{\\textpipe}'},
    # ('||',)
    # ('|\\|\\',)
    ('=\\',):     {'html': '&#x01C2;', 'latex': '{\\textdoublebarpipe}'},
    # ('-\\',)
}

MOD_MAP = {
    ('"',):     {'html': lambda c: c+'&#x0308;', 'latex': lambda c: '\\"{'+c+'}'},
    ('+',):     {'html': lambda c: c+'&#x031F;', 'latex': lambda c: '\\|+{'+c+'}'},
    ('-',):     {'html': lambda c: c+'&#x0320;', 'latex': lambda c: '\\=*{'+c+'}'},
    ('/',):     {'html': lambda c: c+'&#x030C;', 'latex': lambda c: '\\v{'+c+'}'},
    ('0',):     {'html': lambda c: c+'&#x0325;', 'latex': lambda c: '\\r*{'+c+'}'},
    # ('<',)
    ('=',):     {'html': lambda c: c+'&#x0329;', 'latex': lambda c: '\\s{'+c+'}'},
    ('>',):     {'html': lambda c: c+'&#x02BC;', 'latex': lambda c: c+'\''},
    ('?\\',):   {'html': lambda c: c+'&#x02E4;', 'latex': lambda c: c+'\\super Q'},
    # ('\\',):    {'html': lambda c: c+'&#x0302;', 'latex': lambda c: '\\^{'+c+'}'},
    ('^',):     {'html': lambda c: c+'&#x032F;', 'latex': lambda c: '\\textsubarch{'+c+'}'},
    ('}',):     {'html': lambda c: c+'&#x031A;', 'latex': lambda c: c+'{\\textcorner}'},
    ('`',):     {'html': lambda c: c+'&#x02DE;', 'latex': lambda c: c+'{\\textrhoticity}'},
    ('~',):     {'html': lambda c: c+'&#x0303;', 'latex': lambda c: '\\~{'+c+'}'},
    ('A',):     {'html': lambda c: c+'&#x0318;', 'latex': lambda c: '\\|<{'+c+'}'},
    ('a',):     {'html': lambda c: c+'&#x033A;', 'latex': lambda c: '\\|]{'+c+'}'},
    ('B',):     {'html': lambda c: c+'&#x030F;', 'latex': lambda c: '\\H*{'+c+'}'},
    # ('B', 'L'): {'html': lambda c: c+'&#x1DC5;', 'latex': lambda c: '????'},
    ('c',):     {'html': lambda c: c+'&#x031C;', 'latex': lambda c: '\\|({'+c+'}'},
    ('d',):     {'html': lambda c: c+'&#x032A;', 'latex': lambda c: '\\|[{'+c+'}'},
    ('e',):     {'html': lambda c: c+'&#x0334;', 'latex': lambda c: '\\|textsuperimposetilde{'+c+'}'},
    # ('<F>',)
    # ('F',) TODO: this is same is _\
    ('G',):     {'html': lambda c: c+'&#x02E0;', 'latex': lambda c: c+'\\super G'},
    # ('H',)
    # ('H', 'T')
    ('h',):     {'html': lambda c: c+'&#x02B0;', 'latex': lambda c: c+'\\super h'},
    ('j',):     {'html': lambda c: c+'&#x02B2;', 'latex': lambda c: c+'\\super j'},
    ('k',):     {'html': lambda c: c+'&#x0330;', 'latex': lambda c: '\\~*{'+c+'}'},
    # ('L',)
    ('l',):     {'html': lambda c: c+'&#x02E1;', 'latex': lambda c: c+'\\super l'},
    # ('M',)
    ('m',):     {'html': lambda c: c+'&#x033B;', 'latex': lambda c: '\\textsubsquare{'+c+'}'},
    ('N',):     {'html': lambda c: c+'&#x033C;', 'latex': lambda c: '\\|m{'+c+'}'},
    ('n',):     {'html': lambda c: c+'&#x207F;', 'latex': lambda c: c+'\\super n'},
    ('O',):     {'html': lambda c: c+'&#x0339;', 'latex': lambda c: '\\|){'+c+'}'},
    ('o',):     {'html': lambda c: c+'&#x02D5;', 'latex': lambda c: '\\|`{'+c+'}'},
    ('q',):     {'html': lambda c: c+'&#x0319;', 'latex': lambda c: '\\|>{'+c+'}'},
    # ('<R>',)
    # ('R',)
    # ('R', 'F')
    ('r',):     {'html': lambda c: c+'&#x02D4;', 'latex': lambda c: '\\|\'{'+c+'}'},
    ('T',):     {'html': lambda c: c+'&#x030B;', 'latex': lambda c: '\\H{'+c+'}'},
    ('t',):     {'html': lambda c: c+'&#x0324;', 'latex': lambda c: '\\"*{'+c+'}'},
    ('v',):     {'html': lambda c: c+'&#x032C;', 'latex': lambda c: '\\v*{'+c+'}'},
    ('w',):     {'html': lambda c: c+'&#x02B7;', 'latex': lambda c: c+'\\super w'},
    ('X',):     {'html': lambda c: c+'&#x0306;', 'latex': lambda c: '\\u{'+c+'}'},
    ('x',):     {'html': lambda c: c+'&#x033D;', 'latex': lambda c: '\\|x{'+c+'}'},
}
